org.apache.commons.collections4.map

## Class PredicatedMap<K,V>

- java.lang.Object
- - org.apache.commons.collections4.map.AbstractIterableMap<K,V>
  - - org.apache.commons.collections4.map.AbstractMapDecorator<K,V>
    - - org.apache.commons.collections4.map.PredicatedMap<K,V>

- Type Parameters:
    `K` - the type of the keys in this map
    `V` - the type of the values in this map
  All Implemented Interfaces:
    Serializable, Map<K,V>, Get<K,V>, IterableGet<K,V>, IterableMap<K,V>, Put<K,V>
  Direct Known Subclasses:
    PredicatedSortedMap

      public class PredicatedMap<K,V>
      extends AbstractMapDecorator<K,V>
      implements Serializable

  Decorates another `Map` to validate that additions match a specified predicate.

  This map exists to provide validation for the decorated map. It is normally created to decorate an empty map. If an object cannot be added to the map, an IllegalArgumentException is thrown.

  One usage would be to ensure that no null keys are added to the map.

      Map map = PredicatedSet.decorate(new HashMap(), NotNullPredicate.INSTANCE, null);

  Note that PredicatedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedMap(Map)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

  This class is Serializable from Commons Collections 3.1.

  Since:
    3.0
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `Map.Entry<K,V>`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Predicate<? super K>` | `keyPredicate` The key predicate to use
    `protected Predicate<? super V>` | `valuePredicate` The value predicate to use

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `PredicatedMap(Map<K,V> map, Predicate<? super K> keyPredicate, Predicate<? super V> valuePredicate)` Constructor that wraps (not copies).

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected V` | `checkSetValue(V value)` Override to validate an object set into the map via `setValue`.
    `Set<Map.Entry<K,V>>` | `entrySet()`
    `protected boolean` | `isSetValueChecking()` Override to only return true when there is a value transformer.
    `static <K,V> PredicatedMap<K,V>` | `predicatedMap(Map<K,V> map, Predicate<? super K> keyPredicate, Predicate<? super V> valuePredicate)` Factory method to create a predicated (validating) map.
    `V` | `put(K key, V value)` Note that the return type is Object, rather than V as in the Map interface.
    `void` | `putAll(Map<? extends K,? extends V> mapToCopy)`
    `protected void` | `validate(K key, V value)` Validates a key value pair.

    - ### Methods inherited from class org.apache.commons.collections4.map.AbstractMapDecorator

      `clear, containsKey, containsValue, decorated, equals, get, hashCode, isEmpty, keySet, remove, size, toString, values`

    - ### Methods inherited from class org.apache.commons.collections4.map.AbstractIterableMap

      `mapIterator`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, putIfAbsent, remove, replace, replace, replaceAll`

- - ### Field Detail

    - #### keyPredicate

          protected final Predicate<? super K> keyPredicate

      The key predicate to use

    - #### valuePredicate

          protected final Predicate<? super V> valuePredicate

      The value predicate to use

  - ### Constructor Detail

    - #### PredicatedMap

          protected PredicatedMap(Map<K,V> map,
                                  Predicate<? super K> keyPredicate,
                                  Predicate<? super V> valuePredicate)

      Constructor that wraps (not copies).
      Parameters:
        `map` - the map to decorate, must not be null
        `keyPredicate` - the predicate to validate the keys, null means no check
        `valuePredicate` - the predicate to validate to values, null means no check
      Throws:
        `NullPointerException` - if the map is null

  - ### Method Detail

    - #### predicatedMap

          public static <K,V> PredicatedMap<K,V> predicatedMap(Map<K,V> map,
                                                               Predicate<? super K> keyPredicate,
                                                               Predicate<? super V> valuePredicate)

      Factory method to create a predicated (validating) map.

      If there are any elements already in the list being decorated, they are validated.

      Type Parameters:
        `K` - the key type
        `V` - the value type
      Parameters:
        `map` - the map to decorate, must not be null
        `keyPredicate` - the predicate to validate the keys, null means no check
        `valuePredicate` - the predicate to validate to values, null means no check
      Returns:
        a new predicated map
      Throws:
        `NullPointerException` - if the map is null
      Since:
        4.0

    - #### validate

          protected void validate(K key,
                                  V value)

      Validates a key value pair.
      Parameters:
        `key` - the key to validate
        `value` - the value to validate
      Throws:
        `IllegalArgumentException` - if invalid

    - #### checkSetValue

          protected V checkSetValue(V value)

      Override to validate an object set into the map via `setValue`.
      Parameters:
        `value` - the value to validate
      Returns:
        the value itself
      Throws:
        `IllegalArgumentException` - if invalid
      Since:
        3.1

    - #### isSetValueChecking

          protected boolean isSetValueChecking()

      Override to only return true when there is a value transformer.
      Returns:
        true if a value predicate is in use
      Since:
        3.1

    - #### put

          public V put(K key,
                       V value)

      Description copied from interface: `Put`
      Note that the return type is Object, rather than V as in the Map interface. See the class Javadoc for further info.
      Specified by:
        `put` in interface `Map<K,V>`
      Specified by:
        `put` in interface `Put<K,V>`
      Overrides:
        `put` in class `AbstractMapDecorator<K,V>`
      Parameters:
        `key` - key with which the specified value is to be associated
        `value` - value to be associated with the specified key
      Returns:
        the previous value associated with `key`, or `null` if there was no mapping for `key`. (A `null` return can also indicate that the map previously associated `null` with `key`, if the implementation supports `null` values.)
      See Also:
        `Map.put(Object, Object)`

    - #### putAll

          public void putAll(Map<? extends K,? extends V> mapToCopy)

      Specified by:
        `putAll` in interface `Map<K,V>`
      Specified by:
        `putAll` in interface `Put<K,V>`
      Overrides:
        `putAll` in class `AbstractMapDecorator<K,V>`
      Parameters:
        `mapToCopy` - mappings to be stored in this map
      See Also:
        `Map.putAll(Map)`

    - #### entrySet

          public Set<Map.Entry<K,V>> entrySet()

      Specified by:
        `entrySet` in interface `Map<K,V>`
      Specified by:
        `entrySet` in interface `Get<K,V>`
      Overrides:
        `entrySet` in class `AbstractMapDecorator<K,V>`
      Returns:
        a set view of the mappings contained in this map
      See Also:
        `Map.entrySet()`

Copyright © 2001–2018 The Apache Software Foundation. All rights reserved.